if ($Support_EnterVehicleOnClickOnly::Version > 1) {
    return;
}

$Support_EnterVehicleOnClickOnly::Version = 1;

function getAveragePos(%pos1, %pos2) {
    return vectorScale(vectorAdd(%pos1, %pos2) , 0.5);
}

package EnterOnlyOnClick {
    function WheeledVehicleData::onCollision(%db, %vehi, %obj, %objVel, %speed) {
        if (%vehicle.getDatablock().isEnterOnClickOnly && !%obj.isClickToEnter && %obj.getClassName() $= "Player") {
            //talk(%obj.isClickToEnter SPC (%vehicle.getDatablock().isEnterOnClickOnly > 0 ? "click only" : "not click only"));
            if (getWord(%obj.getPosition(), 2) >= getWord(getAveragePos(getWords(%vehi.getObjectBox(), 0, 2), getWords(%vehi.getObjectBox(), 3, 5)), 2) + getWord(%vehi.getPosition(),2)) {
                if (isObject(%cl = %obj.client)) {
                    if (minigameCanUse(%obj, %vehi)) {
                        %cl.bottomprint("\c3Click to enter this vehicle", 1, 1);
                    } else {
                        if (isObject(getMinigameFromObject(%obj))) {
                            %cl.centerprint("This vehicle is not part of the minigame.", 1);
                        } else {
                            %cl.centerprint("This vehicle is part of a minigame.", 1);
                        }
                    }
                    return;
                } else if (minigameCanUse(%obj, %vehi)) { //let bots enter vehicles normally
                    return parent::onCollision(%db, %vehi, %obj, %vec, %val);
                }
            } else if (minigameCanDamage(%vehi, %obj)) {

                %damageMultiplier = %db.collDamageMultiplier;
                %damageThresholdVel = %db.collDamageThresholdVel;

                if (%speed > %damageThresholdVel && !(%obj & $TypeMasks::PlayerObjectType)) {
                    %obj.damage(%damageMultiplier * %speed);
                }
                return;
            }
        }
        return parent::onCollision(%db, %vehi, %obj, %vec, %val);
    }

    function Armor::onTrigger(%db, %obj, %trigger, %val) {
        if (%trigger == 0 && %val && !isObject(%obj.getMountedImage(0))) {
            %start = getWords(%obj.getEyeTransform(), 0, 2);
            %end = vectorAdd(vectorScale(%obj.getEyeVector(), 4), %start);
            %masks = $TypeMasks::VehicleObjectType | $TypeMasks::StaticShapeObjectType | $tTypeMasks::FxBrickObjectType
                        | $TypeMasks::PlayerObjectType | $TypeMasks::TerrainObjectType;
            %ray = containerRaycast(%start, %end, %masks, %obj);

            %hit = getWord(%ray, 0);
            if (isObject(%hit) && strPos(%hit.getClassName(), "Vehicle") > 0 && %obj.lastMountTime < getSimTime() - 2000) {
                if (minigameCanUse(%obj, %hit) && %hit.getDatablock().isEnterOnClickOnly) {
                    %obj.isClickToEnter = 1;
                    %obj.setTransform(getWords(%hit.getPosition(), 0, 1) SPC getWord(getWords(%hit.getObjectBox(), 3, 5), 2) + getWord(%hit.getPosition(),2));
                    WheeledVehicleData::onCollision(%hit.getDatablock(), %hit, %obj, "0 0 4", 4);
                    %obj.isClickToEnter = 0;
                    return;
                } else if (%hit.getDatablock().isEnterOnClickOnly) {
                    if (isObject(getMinigameFromObject(%obj)) && isObject(%cl = %obj.client)) {
                        %cl.centerprint("This vehicle is not part of the minigame.", 1);
                    } else {
                        %cl.centerprint("This vehicle is part of a minigame.", 1);
                    }
                }
            }
        }
        return parent::onTrigger(%db, %obj, %trigger, %val);
    }
};
activatePackage(EnterOnlyOnClick);